#!/usr/bin/env sh

set -e

say() {
  if [ -n "$2" ]; then
    printf "🤖 \e[32mgitea-package\e[0m \e[36m[⚒️ %s]\e[0m: %s \n" "$2" "$1"
  else
    printf "🤖 \e[32mgitea-package\e[0m: %s \n" "$1"
  fi
}

sayE() {
  if [ -n "$2" ]; then
    printf "🤖 \e[31mgitea-package\e[0m \e[36m[⚒️ %s]\e[0m: %s \n" "$2" "$1" 1>&2
  else
    printf "🤖 \e[31mgitea-package\e[0m: %s \n" "$1" 1>&2
  fi
}

sayW() {
  if [ -n "$2" ]; then
    printf "🤖 \e[33mgitea-package\e[0m \e[36m[⚒️ %s]\e[0m: %s \n" "$2" "$1" 1>&2
  else
    printf "🤖 \e[33mgitea-package\e[0m: %s \n" "$1" 1>&2
  fi
}

showHelp() {
  cat << HELP
  🤖 gitea-package Woodpecker-CI Plugin

  Syntax:
HELP
}

showENV() {
  env | sort
}

showSettings() {
  say "PLUGIN_OWNER: $PLUGIN_OWNER" "showSettings"
  say "PLUGIN_PACKAGE_NAME: $PLUGIN_PACKAGE_NAME" "showSettings"
  say "PLUGIN_PACKAGE_VERSION: $PLUGIN_PACKAGE_VERSION" "showSettings"
  say "PLUGIN_FILE_NAME: $PLUGIN_FILE_NAME" "showSettings"
  say "PLUGIN_UPDATE: $PLUGIN_UPDATE" "showSettings"
}

uploadArtifact() {
  curl --user your_username:your_password_or_token \
    --upload-file path/to/file.bin \
    https://gitea.example.com/api/packages/testuser/generic/test_package/1.0.0/file.bin
}

main() {
  if [ -n "$PLUGIN_DEBUG" ]; then
    sayW "Debug mode enabled."
    showSettings
    sayW "Available ENV vars:"
    showENV
    exit 0
  fi
}

main "$@"
